<?php

/**
 * @file
 * The ECA tokens file.
 */

use Drupal\Core\Render\BubbleableMetadata;

/**
 * Implements hook_token_info().
 */
function eca_token_info(): array {
  $info = [];
  $info['types']['dto'] = [
    'name' => t('DTO'),
    'description' => t('Tokens containing arbitrary data (Data Transfer Objects).'),
    'needs-data' => 'array',
    'nested' => TRUE,
    'dynamic' => TRUE,
  ];
  $info['tokens']['dto']['any'] = [
    'name' => t('Any data'),
    'description' => t('Tokens containing arbitrary data, that is passed along process chains defined by ECA (Events, Conditions Actions).'),
  ];
  return $info;
}

/**
 * Implements hook_tokens().
 */
function eca_tokens($type, $tokens, array $data, array $options, BubbleableMetadata $bubbleable_metadata): array {
  $replacements = [];
  if ($type === 'dto' && !empty($data['dto'])) {
    foreach ($tokens as $key => $original) {
      if (isset($data['dto'][$key])) {
        $replacements[$original] = $data['dto'][$key];
      }
    }
  }
  return $replacements;
}
