<?php

namespace Drupal\eca_base\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\eca\Event\ConditionalApplianceInterface;

/**
 * Class CustomEvent
 *
 * @package Drupal\eca_base\Event
 */
class CustomEvent extends Event implements ConditionalApplianceInterface {

  protected string $eventId;

  protected array $arguments = [];

  /**
   * @param string $event_id
   * @param array $arguments
   */
  public function __construct(string $event_id, array $arguments) {
    $this->eventId = $event_id;
    $this->arguments = $arguments;
  }

  /**
   * @return string[]
   */
  public static function fields(): array {
    return [[
      'name' => 'event_id',
      'label' => 'Event ID',
      'type' => 'String',
    ]];
  }

  /**
   * {@inheritdoc}
   */
  public function applies(string $id, array $arguments): bool {
    return !empty($this->eventId) && !empty($arguments['event_id']) && $this->eventId === $arguments['event_id'];
  }

}
