<?php

namespace Drupal\eca_base\Plugin\Action;

use Drupal\eca\Plugin\Action\ActionBase;

/**
 * Action to store arbitrary value to ECA's key value store.
 *
 * @Action(
 *   id = "eca_state_write",
 *   label = @Translation("Persistent state: write")
 * )
 */
class EcaStateWrite extends ActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute(): void {
    $this->state->set($this->configuration['key'], $this->tokenServices->replace($this->configuration['value']));
  }

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration(): array {
    return [
        'key' => '',
        'value' => '',
      ] + parent::defaultConfiguration();
  }

}
