<?php

namespace Drupal\eca_base\Plugin\Action;

use Drupal\eca\Plugin\Action\ConfigurableActionBase;
use Drupal\eca_base\BaseEvents;
use Drupal\eca_base\Event\CustomEvent;

/**
 * Trigger a custom event.
 *
 * @Action(
 *   id = "eca_trigger_custom_event",
 *   label = @Translation("Trigger a custom event")
 * )
 */
class TriggerCustomEvent extends ConfigurableActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute(): void {
    // @todo: Add more arguments when #3232083 got implemented.
    $event = new CustomEvent($this->configuration['event_id'], ['event' => $this->event]);
    \Drupal::service('event_dispatcher')->dispatch($event, BaseEvents::CUSTOM);
  }

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration(): array {
    return [
      'event_id' => '',
    ] + parent::defaultConfiguration();
  }

}
