<?php

namespace Drupal\eca_base\Plugin\ECA\Event;

use Drupal\eca\Plugin\ECA\Event\EventBase;
use Drupal\eca_base\BaseEvents;
use Drupal\eca_base\Event\CronEvent;
use Drupal\eca_base\Event\CustomEvent;

/**
 * Plugin implementation of the ECA base Events.
 *
 * @EcaEvent(
 *   id = "eca_base",
 *   deriver = "Drupal\eca_base\Plugin\ECA\Event\BaseEventDeriver"
 * )
 */
class BaseEvent extends EventBase {

  /**
   * @return array[]
   */
  public static function actions(): array {
    $actions = [];
    $actions['eca_cron'] = [
      'label' => 'ECA cron event',
      'drupal_id' => BaseEvents::CRON,
      'drupal_event_class' => CronEvent::class,
    ];
    $actions['eca_custom'] = [
      'label' => 'ECA custom event',
      'drupal_id' => BaseEvents::CUSTOM,
      'drupal_event_class' => CustomEvent::class,
    ];
    return $actions;
  }

  /**
   * {@inheritdoc}
   */
  public function fields(): array {
    if ($this->drupalEventClass() === CronEvent::class) {
      return CronEvent::fields();
    }
    if ($this->drupalEventClass() === CustomEvent::class) {
      return CustomEvent::fields();
    }
    return parent::fields();
  }

}
