<?php

namespace Drupal\eca_content\Plugin\Condition;

use Drupal\Core\Entity\EntityInterface;
use Drupal\eca\Plugin\Condition\ConditionBase;

/**
 * Plugin implementation of the ECA condition for new entity.
 *
 * @Condition(
 *   id = "eca_entity_is_new",
 *   label = "Entity is new",
 *   context_definitions = {
 *     "entity" = @ContextDefinition("entity", label = @Translation("Entity"))
 *   }
 * )
 */
class EntityIsNew extends ConditionBase {

  /**
   * {@inheritdoc}
   */
  public function evaluate(): bool {
    $entity = $this->getContextValue('entity');
    if ($entity instanceof EntityInterface) {
      return $entity->isNew();
    }
    return FALSE;
  }

}
