<?php

namespace Drupal\eca_user\Plugin\Action;

use Drupal\eca\Plugin\Action\ActionBase;

/**
 * Load current user into token environment.
 *
 * @Action(
 *   id = "eca_token_load_user_current",
 *   label = @Translation("Token: load current user"),
 *   type = "user"
 * )
 */
class TokenLoadUserCurrent extends ActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute($entity = NULL): void {
    if ($entity === NULL) {
      return;
    }
    $this->tokenServices->addTokenData('user', $this->currentUser);
  }

}
