<?php

namespace Drupal\eca\Event;

/**
 * Optional interface for events extending Drupal\Component\EventDispatcher\Event
 * to add more ECA specific methods to those events.
 */
interface ConditionalApplianceInterface {

  /**
   * Verifies if this event should be executed in the current context.
   *
   * @param string $id
   *   The id of the modeller event.
   * @param array $arguments
   *   The modeller event arguments.
   *
   * @return bool
   *   TRUE, if this event should be executed, FALSE otherwise.
   */
  public function applies(string $id, array $arguments): bool;

}
